<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Plugins
 */
/**************************************************************************/

class Delivery_Admin extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("plugin_delivery.tpl");

	$this->AddJScript("/plugins/delivery/admin/delivery.js");
  }

  function Action($action)
  {
    $res=false;
    switch($action)
    { case "addmail": $res=$this->AddMail(); break;
	  case "editmail": $res=$this->EditMail(); break;
	  case "delmail": $res=$this->DelMail(); break;
	  case "setsort": $res=$this->setSort(); break;
	  case "tostream": $res=$this->ToStream(); break;
	  case "delete": $res=$this->Delete(); break;
	  case "send": $res=$this->Send(); break;
	  case "clear": $res=$this->Clear(); break;
	  case "savesuboption": $res=$this->SaveSubOptions(); break;
	  case "allsubs": $res=$this->AllSubs(); break;
	}
    if($res)
	A::goUrl("admin.php?mode=structures&item=".ITEM,array('tab','page'));
  }

  function setSort()
  {
    A_Session::set(STRUCTURE."_sort",$_REQUEST['sort']);
	setcookie(STRUCTURE."_sort",$_REQUEST['sort'],time()+31104000);
	return true;
  }

  function AddMail()
  {
	$_REQUEST['date']=time();
	$_REQUEST['name']=strip_tags($_REQUEST['name']);
	$_REQUEST['content']=$_REQUEST[$_REQUEST['format'].'_content'];

	$dataset = new A_DataSet(STRUCTURE."_mails");
	$dataset->fields=array("date","name","format","content","attach");

    if(isset($_FILES['attach']['tmp_name']) && file_exists($_FILES['attach']['tmp_name']))
	{ if($filename=escapeFileName($_FILES['attach']['name']))
	  { copyfile($_FILES['attach']['tmp_name'],"files/".DOMAIN."/attach/$filename");
	    $_REQUEST['attach']="files/".DOMAIN."/attach/$filename";
	    $dataset->fields[]='attach';
	  }
	}

	if(isset($_REQUEST['tostream']))
	{ $_REQUEST['send']='Y';
	  $dataset->fields[]='send';
	}

    if($id=$dataset->Insert())
	{
	  if(isset($_REQUEST['tostream']))
	  { $_REQUEST['checkmail']=array($id);
	    $this->ToStream();
	  }

	  return true;
	}
	else
	return false;
  }

  function EditMail()
  {
	$dataset = new A_DataSet(STRUCTURE."_mails");
	$dataset->fields=array("date","name","format","content","attach");

	if(isset($_FILES['attach']['tmp_name']) && file_exists($_FILES['attach']['tmp_name']))
	{ if($filename=escapeFileName($_FILES['attach']['name']))
	  { if(!empty($dataset->data['attach']))
	    delfile($dataset->data['attach']);
	    copyfile($_FILES['attach']['tmp_name'],"files/".DOMAIN."/attach/$filename");
	    $_REQUEST['attach']="files/".DOMAIN."/attach/$filename";
	    $_REQUEST['send']='N';
	    $dataset->fields[]='attach';
	  }
	}
	elseif(isset($_REQUEST['delfile']))
	{ delfile($dataset->data['attach']);
	  $_REQUEST['attach']="";
	  $_REQUEST['send']='N';
	  $dataset->fields[]='attach';
	}

	$_REQUEST['name']=strip_tags($_REQUEST['name']);
	$_REQUEST['content']=$_REQUEST[$_REQUEST['format'].'_content'];

	if(isset($_REQUEST['tostream']))
	$_REQUEST['send']='Y';
	elseif($_REQUEST['name']!=$dataset->data['name'] || $_REQUEST['content']!=$dataset->data['content'] || $_REQUEST['format']!=$dataset->data['format'])
	$_REQUEST['send']='N';

	if(!empty($_REQUEST['send']))
	$dataset->fields[]='send';

    if($row=$dataset->Update())
	{
	  if(isset($_REQUEST['tostream']))
	  { $_REQUEST['checkmail']=array($row['id']);
	    $this->ToStream();
	  }

	  return true;
	}
	else
	return false;
  }

  function DelMail($id=0)
  {
	if($id>0)
	$_REQUEST['id']=$id;

	$dataset = new A_DataSet(STRUCTURE."_mails");
    if($row=$dataset->Delete())
	{ if(!empty($row['attach']))
	  delfile($row['attach']);
	  A::$DB->execute("DELETE FROM ".STRUCTURE."_stream WHERE idmail=".$row['id']);
	  return true;
	}
	else
	return false;
  }

  function ToStream()
  {
	if(!empty($_REQUEST['checkmail']) && A::$OPTIONS['subsection'])
	{
	  if($row=A::$DB->getRowById(A::$OPTIONS['subsection'],DOMAIN."_sections"))
      { $section=DOMAIN."_".$row['lang']."_".$row['name'];

	    $field=$row['module']=='users'?A::$OPTIONS['subfield']:'active';
		if(empty($field))
	    $field ='active';

	    $where=A_Session::get(STRUCTURE."_filter","");
	    if(!empty($where)) $where.=" AND ";
	    $where.="{$field}='Y' AND active='Y'";

	    $subids=A::$DB->_getCol("SELECT id FROM {$section} WHERE {$where}");

	    foreach($_REQUEST['checkmail'] as $id)
	    { $id=(integer)$id;

		  foreach($subids as $ids)
	      A::$DB->_execute("INSERT INTO ".STRUCTURE."_stream (idsub,idmail) VALUES($ids,$id)");

		  if(count($subids)>0)
	      A::$DB->_execute("UPDATE ".STRUCTURE."_mails SET send='Y' WHERE id=$id");
	    }

		A::$CACHE->resetDomain(DOMAIN);

	    return true;
	  }
	}
	return false;
  }

  function AllSubs()
  {
    A_Session::set(STRUCTURE."_filter","");
	return true;
  }

  function Delete()
  {
    if(isset($_REQUEST['checkmail']))
	foreach($_REQUEST['checkmail'] as $id)
	$this->DelMail($id);
	return true;
  }

  function Clear()
  {
    A::$DB->execute("DELETE FROM ".STRUCTURE."_stream");
	return true;
  }

  function Send()
  {
    require_once("system/mail/mail.php");

	$row=A::$DB->getRowById(A::$OPTIONS['subsection'],DOMAIN."_sections");
    $section = DOMAIN."_".$row['lang']."_".$row['name'];
	$module=$row['module'];

    A::$DB->queryLimit("
	SELECT s.*,m.name,m.format,m.date,m.content,m.attach
	FROM ".STRUCTURE."_stream AS s
	LEFT JOIN ".STRUCTURE."_mails AS m ON m.id=s.idmail
	ORDER BY id",0,A::$OPTIONS['sendcount']);
	while($row=A::$DB->fetchRow())
	if($user=A::$DB->getRowById($row['idsub'],$section))
	{
      $row['content']=str_replace(array("{username}","{userlogin}"),array($user['name'],$user['login']),$row['content']);

	  if(!empty(A::$OPTIONS['mail'.$row['format']]))
	  { $smarty = new Smarty();
        $smarty->template_dir="templates/".DOMAIN."/mails/";
	    $smarty->compile_dir="templates_c/".DOMAIN."/mails/";
		$smarty->Assign("mail",$row);
	    $smarty->Assign("user",$user);
	    $content=$smarty->fetch(A::$OPTIONS['mail'.$row['format']]);
	  }
	  else
	  $content=$row['content'];

      $mail = new htmlMimeMail();
	  $mail->setFrom(A::$OPTIONS['mailsfrom']);
	  if(A::$OPTIONS['smtp_use'])
      $mail->setSMTPParams(A::$OPTIONS['smtp_host'],A::$OPTIONS['smtp_port'],A::$OPTIONS['smtp_auth'],A::$OPTIONS['smtp_login'],A::$OPTIONS['smtp_password']);
	  $mail->setSubject($row['name']);

	  switch($row['format'])
	  { case "text": $mail->setText($content); break;
	    case "html": $mail->setHTML($content,null,"."); break;
	  }

      if(!empty($row['attach']))
	  { if($data=@file_get_contents($row['attach']))
	    $mail->addAttachment($data,basename($row['attach']),getMimeByFile($row['attach']));
	  }


      $mail->send(array($user['email']),A::$OPTIONS['smtp_use']?"smtp":"mail");

	  A::$DB->execute("DELETE FROM ".STRUCTURE."_stream WHERE id=".$row['id']);
    }
	A::$DB->free();

	return true;
  }

  function SaveSubOptions()
  {
	if(!empty($_REQUEST['subsection']))
	{ setOption(STRUCTURE,"subsection",(integer)$_REQUEST['subsection']);
	  setOption(STRUCTURE,"subfield","");
	}

	if(isset($_REQUEST['subfield']))
	setOption(STRUCTURE,"subfield",preg_replace("/[^a-zA-Z0-9-_]/i","",$_REQUEST['subfield']));

	return true;
  }

  function createData()
  {
	$this->Assign("stream_count",A::$DB->getOne("SELECT COUNT(*) FROM ".STRUCTURE."_stream"));

	$sort=escape_order_string(A_Session::get(STRUCTURE."_sort",isset($_COOKIE[STRUCTURE.'_sort'])?$_COOKIE[STRUCTURE.'_sort']:'date DESC'));

	$mails = array();
	$pager = new A_Pager(20);
  	$pager->query("SELECT * FROM ".STRUCTURE."_mails WHERE visible='Y' ORDER BY {$sort}");
	while($row=$pager->fetchRow())
	$mails[]=$row;
	$pager->free();

	$this->Assign("mails",$mails);
	$this->Assign("mails_pager",$pager);

	$subsections=A::$DB->getAssoc("SELECT id,caption FROM ".DOMAIN."_sections WHERE module='users' OR module='cabinet' OR module='subscribers' ORDER BY sort");
	$this->Assign("subsections",$subsections);

	if($row=A::$DB->getRowById(A::$OPTIONS['subsection'],DOMAIN."_sections"))
	{
	  $section = DOMAIN."_".$row['lang']."_".$row['name'];

	  if($row['module']=='users')
	  $this->Assign("subfields",getFields($section,'bool'));

	  $where=A_Session::get(STRUCTURE."_filter","");

	  $field=$row['module']=='users'? A::$OPTIONS['subfield'] : 'active';
	  if(empty($field))
	  $field='active';

	  if(!empty($where)) $where.=" AND ";
	  $where.="{$field}='Y'";

	  $this->Assign("subcount",A::$DB->getCount($section,$where));
	  $this->Assign("suballcount",A::$DB->getCount($section,"{$field}='Y' AND active='Y'"));
	}

	$this->Assign("optbox1",new A_OptionsBox("Рассылка:",array('idgroup'=>1)));

	$this->Assign("sort",$sort);
  }
}

A::$MAINFRAME = new Delivery_Admin;